basic = [
    "disable_notification",
    "reply_to_message_id",
    "reply_markup"
]

methods = {
    "getMe": (None),
    "logOut": (None),
    "close": (None),
    "sendMessage": (
        [
            "chat_id",
            "text"
        ],
        [
            "parse_mode",
            "entries",
            "disable_web_page_preview",
            *basic
        ]
    ),
    "forwardMessage": (
        [
            "chat_id",
            "from_chat_id",
            "message_id"
        ],
        [
            "disable_notification"
        ]
    ),
    "copyMessage": (
        [
            "chat_id",
            "from_chat_id",
            "message_id"
        ],
        [
            "caption",
            "parse_mode",
            "caption_entities",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendPhoto": (
        [
            "chat_id",
            "photo"
        ],
        [
            "caption",
            "parse_mode",
            "caption_entities",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendAudio": (
        [
            "chat_id",
            "photo"
        ],
        [
            "caption",
            "parse_mode",
            "caption_entities",
            "duration",
            "performer",
            "title",
            "thumb",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendDocument": (
        [
            "chat_id",
            "document"
        ],
        [
            "thumb",
            "caption",
            "parse_mode",
            "caption_entities",
            "disable_content_type_detection",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendVideo": (
        [
            "chat_id",
            "video"
        ],
        [
            "duration",
            "width",
            "height",
            "thumb",
            "caption",
            "parse_mode",
            "caption_entities",
            "supports_streaming",
            "disable_notification",
            *basic
        ]
    ),
    "sendAnimation": (
        [
            "chat_id",
            "animation"
        ],
        [
            "duration",
            "width",
            "height",
            "thumb",
            "caption",
            "parse_mode",
            "caption_entities",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendVoice": (
        [
            "chat_id",
            "voice"
        ],
        [
            "caption",
            "parse_mode",
            "caption_entities",
            "duration",
            "disable_notification",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendVideoNote": (
        [
            "chat_id",
            "video_note"
        ],
        [
            "duration",
            "length",
            "thumb",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendMediaGroup": (
        [
            "chat_id",
            "media"
        ],
        [
            "allow_sending_without_reply",
            "disable_notification",
            "reply_to_message_id"
        ]
    ),
    "sendLocation": (
        [
            "chat_id",
            "latitude",
            "longitude"
        ],
        [
            "horizontal_accuracy",
            "live_period",
            "heading",
            "proximity_alert_radius",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "editMessageLiveLocation": (
        [
            [
                "chat_id",
                "message_id"
            ],
            [
                "inline_message_id"
            ]
        ],
        [
            "latitude",
            "longitude",
            "horizontal_accuracy",
            "heading",
            "proximity_alert_radius",
            "reply_markup"
        ]
    ),
    "stopMessageLiveLocation": (
        [
            [
                "chat_id",
                "message_id"
            ],
            [
                "inline_message_id"
            ]
        ],
        [
            "reply_markup"
        ]
    ),
    "sendVenue": (
        [
            "chat_id",
            "latitude",
            "longitude",
            "title",
            "address"
        ],
        [
            "foursquare_id",
            "foursquare_type",
            "google_place_id",
            "google_place_type",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendContact": (
        [
            "chat_id",
            "phone_number",
            "first_name"
        ],
        [
            "last_name",
            "vcard",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendPoll": (
        [
            "chat_id",
            "question",
            "options"
        ],
        [
            "is_anonymous",
            "type",
            "allows_multiple_answers",
            "correct_option_id",
            "explanation",
            "explanation_parse_mode",
            "explanation_entities",
            "open_period",
            "close_date",
            "is_closed",
            "disable_notification",
            "allow_sending_without_reply",
            *basic
        ]
    ),
    "sendDice": (
        [
            "chat_id",
        ],
        [
            "emoji",
            "allow_sending_without_reply",
            *basic
        ]
    )
}
